diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index de875eca7..26ae0ce10 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -5,6 +5,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.AgedMob;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.entity.monster.MobZombiePig;
@@ -13,6 +14,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -26,6 +28,7 @@ public class MobPig
 //    implements AgedMob
 {
     public static final int DATA_SADDLE_ID = 16;
+    public static final int DATA_SIT_ID = 17;
 
     public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
 //    private final @NotNull MobAge age;
@@ -50,6 +53,7 @@ public class MobPig
     @Override
 	protected void defineSynchedData() {
         this.entityData.define(DATA_SADDLE_ID, (byte) 0, Byte.class);
+        this.entityData.define(DATA_SIT_ID, (byte) 0, Byte.class);
     }
 
     @Override
@@ -57,6 +61,7 @@ public class MobPig
     {
         super.addAdditionalSaveData(tag);
         tag.putBoolean("Saddle", getSaddled());
+        tag.putBoolean("Sit", getSitting());
 //        this.age.writeTag(tag);
     }
 
@@ -65,16 +70,208 @@ public class MobPig
     {
         super.readAdditionalSaveData(tag);
         setSaddled(tag.getBoolean("Saddle"));
+        setSitting(tag.getBoolean("Sit"));
 //        this.age.readTag(tag);
     }
 
+    @Override
+    public boolean save(@NotNull CompoundTag tag) {
+        if (this.passenger instanceof Player) {
+            return false;
+        }
+        return super.save(tag);
+    }
+
+    private static final double MAX_CONTROL_HORIZONTAL_STEP = 1.0D;
+    private static final double MAX_CONTROL_VERTICAL_STEP = 2.0D;
+
+    private double controlTargetX;
+    private double controlTargetY;
+    private double controlTargetZ;
+    private boolean hasControlTarget;
+    private float pendingFallDistance;
+
+    private double lastStandingY;
+    private boolean wasGrounded;
+    private boolean airborneFromJump;
+
+    private static final float JUMP_LANDING_KEEP = 0.1f;
+    private static final float WALL_HIT_SPEED_LOSS = 0.12f;
+
+    private static final float NORMAL_MOVE_SPEED = 0.7f;
+    private static final float PANIC_MOVE_SPEED = 1.3f;
+    private static final int PANIC_DURATION_TICKS = 60;
+    private int panicTicks = 0;
+
+    public float lookFadeAlpha = 1.0f;
+    public long lookFadeLastRenderNanos = 0L;
+
+    @Override
+    public void setPassenger(Entity passenger) {
+        super.setPassenger(passenger);
+        this.hasControlTarget = false;
+        this.airborneFromJump = false;
+        if (passenger != null) {
+            setSitting(false);
+            this.panicTicks = 0;
+        }
+        if (passenger == null) {
+            this.xd = 0.0D;
+            this.yd = 0.0D;
+            this.zd = 0.0D;
+            this.speedProgress = 0f;
+            this.fallDistance = 0f;
+            if (getSaddled()) {
+                setSitting(true);
+            }
+        }
+    }
+
     @Override
     public void onLivingUpdate() {
+        if (this.passenger instanceof Player driver) {
+            if (!driver.lerpVehicleMotion()) {
+                this.newPosRotationIncrements = 0;
+                boolean wasMultiplayerEntity = this.isMultiplayerEntity;
+                boolean wasLocallySimulated = this.locallySimulated;
+                this.isMultiplayerEntity = false;
+                this.locallySimulated = true;
+                super.onLivingUpdate();
+                this.isMultiplayerEntity = wasMultiplayerEntity;
+                this.locallySimulated = wasLocallySimulated;
+                driver.sendSpecialVehiclePacket();
+                return;
+            }
+            if (!this.world.isClientSide) {
+                this.target = null;
+                this.pathToEntity = null;
+                this.yBodyRot = this.yRot;
+                this.xRot = driver.xRot;
+                this.fallDistance = 0f;
+                if (this.hasControlTarget) {
+                    double trueY = this.bb.minY + (double) this.heightOffset;
+                    double dx = MathHelper.clamp(this.controlTargetX - this.x, -MAX_CONTROL_HORIZONTAL_STEP, MAX_CONTROL_HORIZONTAL_STEP);
+                    double dy = MathHelper.clamp(this.controlTargetY - trueY, -MAX_CONTROL_VERTICAL_STEP, MAX_CONTROL_VERTICAL_STEP);
+                    double dz = MathHelper.clamp(this.controlTargetZ - this.z, -MAX_CONTROL_HORIZONTAL_STEP, MAX_CONTROL_HORIZONTAL_STEP);
+                    move(dx, dy, dz);
+                }
+                this.xd = 0.0D;
+                this.yd = 0.0D;
+                this.zd = 0.0D;
+                return;
+            }
+        }
         super.onLivingUpdate();
 
 //        this.age.tick(this.world);
     }
 
+    @Override
+    public void handleControlDirect(double x, double y, double z, float yRot) {
+        this.yRot = yRot;
+        this.yBodyRot = yRot;
+        this.controlTargetX = x;
+        this.controlTargetY = y;
+        this.controlTargetZ = z;
+        this.hasControlTarget = true;
+    }
+
+    @Override
+    public boolean isInWall() {
+        if (!this.world.isClientSide && this.passenger instanceof Player) {
+            return false;
+        }
+        return super.isInWall();
+    }
+
+    @Override
+    public void move(double dx, double dy, double dz) {
+        if (!hasNoPhysics() && this.passenger instanceof Player rider && rider.bb.maxY > this.bb.maxY) {
+            final double pigHeight = this.bb.maxY - this.bb.minY;
+            this.bb.maxY = rider.bb.maxY;
+            super.move(dx, dy, dz);
+            this.bb.maxY = this.bb.minY + pigHeight;
+            return;
+        }
+        super.move(dx, dy, dz);
+    }
+
+    @Override
+    public boolean passesThroughRiderTargeting(ItemStack heldItem) {
+        boolean canFeed = heldItem != null
+            && (heldItem.itemID == Blocks.MUSHROOM_BROWN.id() || heldItem.itemID == Blocks.MUSHROOM_RED.id())
+            && getHealth() < getMaxHealth();
+        return !canFeed;
+    }
+
+    @Override
+    public boolean hurt(Entity attacker, int damage, DamageType type) {
+        if (attacker != null && attacker == this.passenger) {
+            return false;
+        }
+        boolean hurt = super.hurt(attacker, damage, type);
+        if (hurt) {
+            this.speedProgress = 0f;
+            if (!this.world.isClientSide && this.passenger == null && (getSitting() || this.panicTicks > 0)) {
+                setSitting(false);
+                this.panicTicks = PANIC_DURATION_TICKS;
+            }
+        }
+        return hurt;
+    }
+
+    @Override
+    public void handleEntityEvent(byte event, float attackedAtYaw) {
+        super.handleEntityEvent(event, attackedAtYaw);
+        if (event == 2) {
+            this.speedProgress = 0f;
+        }
+    }
+
+    @Override
+    protected void jump() {
+        super.jump();
+        if (this.passenger instanceof Player) {
+            this.airborneFromJump = true;
+        }
+    }
+
+    @Override
+    public void fling(double xd, double yd, double zd, float pushTime) {
+        super.fling(xd, yd, zd, pushTime);
+        if (!this.world.isClientSide && this.passenger instanceof Player rider) {
+            rider.onVehicleFlung(this);
+        }
+    }
+
+    @Override
+    public Entity ejectRider() {
+        Entity rider = super.ejectRider();
+        this.xd = 0.0D;
+        this.yd = 0.0D;
+        this.zd = 0.0D;
+        this.speedProgress = 0f;
+        this.fallDistance = 0f;
+        this.airborneFromJump = false;
+        if (getSaddled()) {
+            setSitting(true);
+        }
+        return rider;
+    }
+
+    /**
+     * Drops <= 0.5 of a block lose no speed, past that the speed loss starts at ~25% and curves up to ~85% at a full
+     * block, and capped at 95% around 1.5 blocks.
+     */
+    private static float landingSpeedKeep(float netDrop) {
+        if (netDrop <= 0.5f) {
+            return 1f;
+        }
+        float x = (netDrop - 0.5f) / 0.5f;
+        float loss = 0.25f + 0.6f * x * x;
+        return MathHelper.clamp(1f - loss, 0.05f, 1f);
+    }
+
     @Override
     protected void updateAI() {
         if (this.passenger instanceof Player) {
@@ -84,9 +281,27 @@ public class MobPig
             this.moveForward = 0f;
             this.moveStrafing = 0f;
 
+            if (this.onGround && !this.wasGrounded) {
+                float keep = this.airborneFromJump
+                    ? JUMP_LANDING_KEEP
+                    : landingSpeedKeep((float) (this.lastStandingY - this.y));
+                this.xd *= keep;
+                this.zd *= keep;
+                this.speedProgress *= keep;
+                this.airborneFromJump = false;
+            }
+            if (this.onGround) {
+                this.lastStandingY = this.y;
+            }
+            this.wasGrounded = this.onGround;
+
+            if (this.horizontalCollision) {
+                this.speedProgress = Math.max(0f, this.speedProgress - WALL_HIT_SPEED_LOSS);
+            }
+
             var friction = this.world.getBlockType(this.queryPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y - 1), MathHelper.floor(this.z))).friction;
             final float accel = MathHelper.lerp(3, 10f * (1 + (0.6f - friction)), this.speedProgress) * (!this.onGround ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
-            final float maxSpeed = MathHelper.lerp(0.15f, 0.5f * (1 - (0.6f - friction)/2.5f), this.speedProgress) * (!(this.onGround || this.yd < 0) ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
+            final float maxSpeed = MathHelper.lerp(0.15f, 0.5f * (1 - (0.6f - friction)/2.5f), this.speedProgress) * (isInWater() ? 0.5f : 1f);
 
             double pXd = this.passenger.xd;
             double pZd = this.passenger.zd;
@@ -103,14 +318,17 @@ public class MobPig
                 pZd *= vel;
             }
 
+            double externalSpeed = Math.sqrt(this.xd * this.xd + this.zd * this.zd);
+            double effectiveMax = Math.max(maxSpeed, externalSpeed);
+
             this.xd += pXd * accel;
             this.zd += pZd * accel;
 
             double spdsqrd = this.xd * this.xd + this.zd * this.zd;
-            if (spdsqrd > maxSpeed * maxSpeed) {
+            if (spdsqrd > effectiveMax * effectiveMax) {
                 double speed = Math.sqrt(spdsqrd);
-                this.xd = (this.xd / speed) * maxSpeed;
-                this.zd = (this.zd / speed) * maxSpeed;
+                this.xd = (this.xd / speed) * effectiveMax;
+                this.zd = (this.zd / speed) * effectiveMax;
             }
 
             this.xRot = this.passenger.xRot;
@@ -119,7 +337,9 @@ public class MobPig
 
             this.isJumping = isInWater() || ((Player) this.passenger).isJumping();
 
-            if ((this.onGround || this.yd < 0) && !isInWater() && !this.isJumping) {
+            if (isInWater()) {
+                this.speedProgress = 0f;
+            } else if (this.onGround && !this.isJumping) {
                 if (pXd * pXd + pZd * pZd > 0.000005f) {
                     this.speedProgress += (1/200f) * (1 + (0.6f - friction) * 1.5f);
                     this.speedProgress *= (1.000f + 0.025f * (1 + (0.6f - friction) * 1.5f));
@@ -127,15 +347,35 @@ public class MobPig
                     this.speedProgress *= 0.9f;
                 }
                 this.speedProgress = MathHelper.clamp(this.speedProgress, 0, 1);
-            } else {
-                this.speedProgress = 0f;
+            }
+        } else if (this.panicTicks > 0) {
+            this.footSize = 0.5f;
+            this.panicTicks--;
+            this.moveSpeed = PANIC_MOVE_SPEED;
+            if (this.pathToEntity == null || this.random.nextInt(10) == 0) {
+                roamRandomPath();
+            }
+            super.updateAI();
+            if (this.panicTicks <= 0 && getSaddled() && this.passenger == null) {
+                setSitting(true);
             }
         } else {
             this.footSize = 0.5f;
+            this.moveSpeed = NORMAL_MOVE_SPEED;
             super.updateAI();
         }
     }
 
+    @Override
+    protected void checkForPlayerHoldingItem() {
+        if (this.panicTicks > 0) {
+            setTarget(null);
+            this.closestPlayer = null;
+            return;
+        }
+        super.checkForPlayerHoldingItem();
+    }
+
     @Override
     public void positionRider() {
         super.positionRider();
@@ -189,30 +429,40 @@ public class MobPig
     {
         if (super.interact(player)) return true;
         ItemStack heldItem = player.getHeldItem();
-        if (heldItem != null && (heldItem.itemID == Blocks.MUSHROOM_BROWN.id() || heldItem.itemID == Blocks.MUSHROOM_RED.id()) && heldItem.consumeItem(player)) {
+        if (heldItem != null && (heldItem.itemID == Blocks.MUSHROOM_BROWN.id() || heldItem.itemID == Blocks.MUSHROOM_RED.id())
+            && getHealth() < getMaxHealth() && heldItem.consumeItem(player)) {
             heal(4);
+
+            this.world.playSoundAtEntity(player, this, "random.bite",
+                0.2f + (this.random.nextFloat() - this.random.nextFloat()) * 0.1f,
+                0.8f + (this.random.nextFloat() - this.random.nextFloat()) * 0.1f);
             return true;
         }
-        if (!this.world.isClientSide) {
-            if (getSaddled()) {
-                if (player.isSneaking()) {
-                    if (this.passenger == null) {
-                        setSaddled(false);
-                        ItemStack toInsert = new ItemStack(Items.SADDLE);
-                        player.inventory.insertItem(toInsert, true);
-                        if (toInsert.stackSize > 0) {
-                            dropItem(toInsert, 0.0f);
-                        }
-                        return true;
-                    }
-                }
-                if (this.passenger == null || this.passenger == player) {
-                    player.startRiding(this);
-                    return true;
-                }
+        if (this.passenger == player) {
+            return false;
+        }
+        if (!getSaddled()) {
+            return false;
+        }
+        if (this.passenger != null) {
+            return false;
+        }
+        if (this.world.isClientSide) {
+            return true;
+        }
+        if (player.isSneaking()) {
+            setSaddled(false);
+            setSitting(false);
+            this.panicTicks = 0;
+            ItemStack toInsert = new ItemStack(Items.SADDLE);
+            player.inventory.insertItem(toInsert, true);
+            if (toInsert.stackSize > 0) {
+                dropItem(toInsert, 0.0f);
             }
+        } else {
+            player.startRiding(this);
         }
-        return false;
+        return true;
     }
 
     @Override
@@ -257,6 +507,29 @@ public class MobPig
         }
     }
 
+    public boolean getSitting()
+    {
+        return (this.entityData.getByte(DATA_SIT_ID) & 1) != 0;
+    }
+
+    public void setSitting(boolean flag)
+    {
+        this.entityData.set(DATA_SIT_ID, (byte) (flag ? 1 : 0));
+        if (flag) {
+            this.xd = 0.0D;
+            this.zd = 0.0D;
+            this.moveForward = 0f;
+            this.moveStrafing = 0f;
+            this.pathToEntity = null;
+            this.panicTicks = 0;
+        }
+    }
+
+    @Override
+    protected boolean isMovementCeased() {
+        return getSitting() || super.isMovementCeased();
+    }
+
     @Override
 	public void thunderHit(EntityLightning bolt)
     {
@@ -273,9 +546,33 @@ public class MobPig
 
     @Override
 	protected void causeFallDamage(float distance) {
+        if (this.passenger instanceof Player driver) {
+            if (this.world.isClientSide) {
+                this.pendingFallDistance = distance;
+            } else if (!driver.lerpVehicleMotion()) {
+                applyRiderFallDamage(distance);
+            }
+            return;
+        }
         super.causeFallDamage(distance);
-        if(distance > 5F && (this.passenger instanceof Player)) {
-            ((Player) this.passenger).triggerAchievement(Achievements.FLY_PIG);
+    }
+
+    public float consumePendingFallDistance() {
+        float distance = this.pendingFallDistance;
+        this.pendingFallDistance = 0f;
+        return distance;
+    }
+
+    public void applyRiderFallDamage(float distance) {
+        if (this.world.isClientSide) {
+            return;
+        }
+        if (distance > 5F && this.passenger instanceof Player rider) {
+            rider.triggerAchievement(Achievements.FLY_PIG);
+        }
+        int damage = (int) Math.ceil(distance - 3F);
+        if (damage > 0) {
+            hurt(null, damage, DamageType.FALL);
         }
     }
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 6edabf547..a06599cbe 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -127,6 +127,7 @@ public abstract class Player
     public float timeInPortal;
     public float prevTimeInPortal;
     public @Nullable EntityFishingBobber bobberEntity;
+    private @Nullable CompoundTag pendingVehicleTag;
     protected @Nullable ICarriable heldObject;
     public volatile String skinURL;
     public volatile String capeURL;
@@ -257,6 +258,15 @@ public abstract class Player
 
     @Override
     public void tick() {
+        if (this.pendingVehicleTag != null && !this.world.isClientSide) {
+            CompoundTag vehicleTag = this.pendingVehicleTag;
+            this.pendingVehicleTag = null;
+            Entity vehicle = EntityDispatcher.getInstance().createEntityFromNBT(vehicleTag, this.world);
+            if (vehicle instanceof MobPig pig) {
+                this.world.entityJoinedWorld(pig);
+                startRiding(pig);
+            }
+        }
         if (this.world.getDimension() == Dimension.NETHER) {
             addStat(Achievements.ENTER_NETHER, 1);
             if (random.nextInt(20) == 0) {
@@ -287,7 +297,7 @@ public abstract class Player
 
         final boolean wSneak = wantSneak();
 
-        if (wSneak || hasNoPhysics()) {
+        if (wSneak || hasNoPhysics() || this.vehicle != null) {
             this.sneaking = wSneak;
         } else {
             if (boundsClear(getBoundsForState(MOTION_STATE_DEFAULT))) {
@@ -373,6 +383,9 @@ public abstract class Player
         addMountedMovementStat(this.x - xdO, this.y - ydO, this.z - zdO);
     }
 
+    public void onVehicleFlung(Entity vehicle) {
+    }
+
     @Override
     public void resetPos() {
         setupScale();
@@ -955,6 +968,9 @@ public abstract class Player
             CompoundTag heldTag = tag.getCompound("HeldObject");
             this.heldObject = ICarriable.createAndLoadCarriable(this, heldTag);
         }
+        if (tag.containsKey("Vehicle")) {
+            this.pendingVehicleTag = tag.getCompound("Vehicle");
+        }
     }
 
     @Override
@@ -986,6 +1002,16 @@ public abstract class Player
             this.heldObject.writeToNBT(heldTag);
             tag.put("HeldObject", heldTag);
         }
+
+        if (this.vehicle instanceof MobPig pig) {
+            var vehicleId = pig.getDispatcherId();
+            if (vehicleId != null) {
+                CompoundTag vehicleTag = new CompoundTag();
+                vehicleTag.putString("id", vehicleId.toString());
+                pig.saveWithoutId(vehicleTag);
+                tag.put("Vehicle", vehicleTag);
+            }
+        }
     }
 
     @Override
@@ -1000,6 +1026,10 @@ public abstract class Player
     public void displayContainerScreen(Container container) {
     }
 
+    public void clearPendingVehicleTag() {
+        this.pendingVehicleTag = null;
+    }
+
     public void displayChestScreen(Container container, double x, double y, double z) {
     }
 
@@ -1180,12 +1210,12 @@ public abstract class Player
         return false;
     }
 
-    public boolean useCurrentItemOnEntity(Entity entity) {
-        boolean flag = false;
+    public boolean useCurrentItemOnEntity(@NotNull Entity entity) {
         if (entity.interact(this)) {
             swingItem();
-            flag = true;
+            return true;
         }
+        boolean flag = false;
         ItemStack itemstack = getCurrentEquippedItem();
         if (itemstack != null && (entity instanceof Mob)) {
             if (itemstack.useItemOnEntity(this, (Mob) entity)) {
@@ -1689,6 +1719,9 @@ public abstract class Player
     }
 
     public void setNoclip(final boolean noclip) {
+        if (noclip && this.vehicle != null) {
+            return;
+        }
         setNoPhysics(noclip);
         if (hasNoPhysics()) {
             this.yd += 0.079f;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 1536ee0d6..f0a9a8e52 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -396,8 +396,14 @@ public class EntityBoat extends Entity implements ICollidable {
         this.pendingZDChange = Math.sin(Math.toRadians(this.yRot)) * velOff;
     }
 
-    public void handleControlDirect(float xd, float zd, float yRot) {
-        this.yRot = (float) MathHelper.clamp(yRot, this.yRot - MAX_PACKET_ROTATION_CHANGE, this.yRot + MAX_PACKET_ROTATION_CHANGE);
+    @Override
+    public boolean relaysVehicleControl() {
+        return true;
+    }
+
+    @Override
+    public void handleControlDirect(double xd, double yd, double zd, float yRot) {
+        this.yRot = (float) MathHelper.clamp((double) yRot, this.yRot - MAX_PACKET_ROTATION_CHANGE, this.yRot + MAX_PACKET_ROTATION_CHANGE);
         this.xd = MathHelper.clamp(xd, this.xd - MAX_PACKET_SPEED_CHANGE, this.xd + MAX_PACKET_SPEED_CHANGE);
         this.zd = MathHelper.clamp(zd, this.zd - MAX_PACKET_SPEED_CHANGE, this.zd + MAX_PACKET_SPEED_CHANGE);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
index 3675e69d9..bfc022998 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
@@ -16,6 +16,7 @@ public class ItemSaddle extends Item {
     public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
         if(!player.isSneaking() && mob instanceof MobPig pig && !pig.getSaddled() && selfStack.consumeItem(player)) {
             pig.setSaddled(true);
+            pig.setSitting(true);
             return true;
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
index d1f1e7ad8..171d645df 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
@@ -101,9 +101,19 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
                             EntitySelector targetEntitySelector = c.getArgument("target", EntitySelector.class);
                             Entity targetEntity = targetEntitySelector.get(c.getSource()).get(0);
 
+                            double x = targetEntity.x;
+                            double y = targetEntity.y - targetEntity.heightOffset;
+                            double z = targetEntity.z;
+                            int targetDimension = targetEntity instanceof Player ? ((Player) targetEntity).dimension : targetEntity.world.dimension.id;
+
                             List<? extends Entity> entities = entitySelector.get(c.getSource());
                             for (Entity entity : entities) {
-                                entity.moveTo(targetEntity.x, targetEntity.y - targetEntity.heightOffset, targetEntity.z, entity.yRot, entity.xRot);
+                                if (entity instanceof Player player) {
+                                    if (player.dimension != targetDimension) source.movePlayerToDimension(player, targetDimension);
+                                    source.teleportPlayerToPos(player, x, y, z);
+                                } else {
+                                    entity.moveTo(x, y, z, entity.yRot, entity.xRot);
+                                }
                             }
 
                             if (entities.size() == 1) source.sendTranslatableMessage("command.commands.teleport.entity.success_single_entity", CommandHelper.getEntityName(entities.get(0)), CommandHelper.getEntityName(targetEntity));
diff --git a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index e4ebde803..609a47978 100644
--- a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -211,6 +211,7 @@ public abstract class PacketHandler {
         handleInvalidPacket(packetSetHeldObject);
     }
 
+    @Deprecated
     public void handleContainerAck(@NotNull PacketContainerAck packetContainerAck) {
         handleInvalidPacket(packetContainerAck);
     }
@@ -219,8 +220,8 @@ public abstract class PacketHandler {
         handleInvalidPacket(packetAddPainting);
     }
 
-    public void handleBoatControl(@NotNull PacketBoatControl packetBoatControl) {
-        handleInvalidPacket(packetBoatControl);
+    public void handleVehicleControl(@NotNull PacketVehicleControl packetVehicleControl) {
+        handleInvalidPacket(packetVehicleControl);
     }
 
     public void handleBlockEvent(@NotNull PacketBlockEvent packetBlockEvent) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index 8e3aaf97f..c871d0372 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -279,7 +279,7 @@ public abstract class Packet
         addMapping(23, true, false, PacketAddEntity.class);
         addMapping(24, true, false, PacketAddMob.class);
         addMapping(25, true, false, PacketAddPainting.class);
-        addMapping(26, true, true, PacketBoatControl.class);
+        addMapping(26, true, true, PacketVehicleControl.class);
         addMapping(27, true, true, PacketSetHeldObject.class);
         addMapping(28, true, false, PacketSetEntityMotion.class);
         addMapping(29, true, false, PacketRemoveEntity.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerAck.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerAck.java
index fae9fde6b..7ed15eb4c 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerAck.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerAck.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
+@Deprecated
 public class PacketContainerAck extends Packet
 {
 
@@ -19,13 +21,13 @@ public class PacketContainerAck extends Packet
     }
 
     @Override
-	public void handlePacket(PacketHandler packetHandler)
+	public void handlePacket(@NotNull PacketHandler packetHandler)
     {
         packetHandler.handleContainerAck(this);
     }
 
     @Override
-	public void read(DataInputStream dis)
+	public void read(@NotNull DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -34,7 +36,7 @@ public class PacketContainerAck extends Packet
     }
 
     @Override
-	public void write(DataOutputStream dos)
+	public void write(@NotNull DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
